package com.cemarose.mongodb.service.impl;
import com.cemarose.mongodb.model.Users;
import com.cemarose.mongodb.service.IUserService;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.data.mongodb.core.query.Update;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

@Service
public class UserServiceImpl implements IUserService {
    @Resource
    MongoTemplate mongoTemplate;


    public void saveUser(Users users) {
        mongoTemplate.save(users);
    }

    public Users findUserByName(String name) {
        return mongoTemplate.findOne(new Query(Criteria.where("name").is(name)), Users.class);
    }

    public void removeUser(String name) {
        mongoTemplate.remove(new Query(Criteria.where("name").is(name)), Users.class);
    }

    public void updateUser(String name, String key, String value) {
        mongoTemplate.updateFirst(new Query(Criteria.where("name").is(name)), Update.update(key, value), Users.class);
    }

    public List<Users> listUser() {
        return mongoTemplate.findAll(Users.class);
    }

    @Override
    public Users findById(String id) {
        return mongoTemplate.findById(id, Users.class);
    }


    @Override
    public Users findByCondition(Integer id) {
        return mongoTemplate.findOne(new Query(Criteria.where("id").is(id)), Users.class);
    }

}
