package com.cemarose.mongodb.test;

import com.cemarose.mongodb.model.Users;
import com.cemarose.mongodb.service.IUserService;
import com.mongodb.util.JSON;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.data.mongodb.core.MongoTemplate;

import javax.annotation.Resource;


@SpringBootApplication
@ComponentScan(basePackages={"com.cemarose.mongodb"})
public class SpringbootMongodbApplication implements CommandLineRunner {

	@Resource
	private IUserService userService;
	@Autowired
	MongoTemplate mongoTemplate;



	public static void main(String[] args) {
		SpringApplication.run(SpringbootMongodbApplication.class, args);
	}

	/**
	 * 描述：用于启动测试mongodb链接与查询
	 * 说明：
	 * 		数据库：dbtest;
	 * 		集合：users;
	 * 		数据结构：{_id: ObjectId("5b45a855cf1b862af02414af"), id: NumberInt(1), name: "张三" }
	 * @param args
	 * @throws Exception
	 */
	@Override
	public void run(String... args) throws Exception {
		try {
			//取不到值，springboot默认findById是根据mongodb中的_id的值来查询的
			Users users = userService.findById("1");
			if (users != null) {
				System.out.println(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>" + users.getId() + "----" + users.getName());
			}else{
				System.out.println(">>>>>>>>>>>>>empty>>>>>>>>>>>>>>>>>>");
			}

			//根据mongodb的_id来查询；可查询到值
			Users users2 =mongoTemplate.findById("5b45a855cf1b862af02414af", Users.class);

			//根据名称来查询；可查询到值
			Users users3 =userService.findUserByName("张三");

			//自己封装的方法；根据自己的id来查询数据； 备注说明：必须在实体中定义一个@Id来指定与mongodb中的_id对应；否则默认会以id与mongodb中的_id相对应
			Users user111 = userService.findByCondition(1);
			System.out.println("---------------------");
		} catch (Exception e) {
			e.printStackTrace();
		}
	}




}